VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TPart"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private cnn As ADODB.Connection
Private sID As String
Private sPlan As String
Private sType As String
Private lTag As Long
Private mCol As Collection
Public TreeIndex As Long

Public Property Get BOM() As Collection
    Set BOM = mCol
End Property

Public Property Get Description() As String
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT DESCR FROM PART000 WHERE PARTID='" & sID & "';"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then
        s = ""
        s = Trim(Nz(rst(0).Value, ""))
    Else
        s = ""
    End If
    Set rst = Nothing
    Err.Clear
    If s = "" Then
        s = "SELECT DESCR FROM MATL001 WHERE MATERIALID='" & sID & "';"
        Set rst = cnn.Execute(s, , adCmdText)
        If Err.Number = 0 Then
            s = ""
            s = Trim(Nz(rst(0).Value, ""))
        Else
            s = ""
        End If
        Set rst = Nothing
    End If
    If s = "" Then s = sID
    Description = s
End Property

Private Property Get FirstJS() As TProc
    On Error Resume Next
    Dim s As String
    Dim po As TProc
    Dim rst As ADODB.Recordset
    
    s = "SELECT FIRSTJS FROM PROCPLN000 WHERE PROCPLANID='" & sID & "';"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then
        s = ""
        s = Trim(Nz(rst(0).Value, ""))
        If s <> "" Then
            Set po = New TProc
            po.ID = s
            po.ProcPlan = sID
        End If
    End If
    Set rst = Nothing
    Set FirstJS = po
End Property

Public Property Get ID() As String
    ID = sID
End Property
Public Property Let ID(ByVal s As String)
    sID = s
End Property

Public Property Get ProcPlan() As String
    ProcPlan = sPlan
End Property
Public Property Let ProcPlan(ByVal s As String)
    sPlan = s
End Property

Public Property Get PartType() As String
    PartType = sType
End Property

Public Property Get Quantity() As Double
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT QUANTITY FROM BOM000 WHERE (MATERIALID='" & sID & _
        "') AND (PROCPLANID='" & sPlan & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then Quantity = Nz(rst(0).Value, 0)
    Set rst = Nothing
End Property

Public Property Get QuantityOnHand() As Double
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT QUONHAND FROM MATL001 WHERE MATERIALID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then QuantityOnHand = Nz(rst(0).Value, 0)
    Set rst = Nothing
End Property

Public Property Get Tag() As Long
    Tag = lTag
End Property

Public Sub Load(LoadOperations As Boolean)
    AddParts LoadOperations
    If LoadOperations Then AddProcs
    If mCol.Count > 0 Then
        sType = "Manufactured"
        lTag = 1
    End If
End Sub

Private Sub Class_Initialize()
    Set cnn = Data
    Set mCol = New Collection
    sID = ""
    sPlan = ""
    sType = "Purchased"
    lTag = 2
    TreeIndex = -1
End Sub
Private Sub Class_Terminate()
    Set cnn = Nothing
    Set mCol = Nothing
End Sub

Private Sub AddParts(LoadOperations As Boolean)
    On Error Resume Next
    Dim s As String
    Dim po As TPart
    Dim rst As ADODB.Recordset

    s = "SELECT MATERIALID FROM BOM000 WHERE PROCPLANID='" & sID & "';"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then
        While Not rst.EOF
            Set po = New TPart
            po.ID = Trim(Nz(rst(0).Value, ""))
            If po.ID <> "" Then
                po.ProcPlan = sID
                mCol.Add po
                po.Load LoadOperations
            End If
            rst.MoveNext
        Wend
    End If
    Set rst = Nothing
End Sub

Private Sub AddProcs()
    On Error Resume Next
    Dim po As TProc
    
    Set po = FirstJS
    While Not (po Is Nothing)
        mCol.Add po
        Set po = po.NextJS
    Wend
End Sub

