VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "TProc"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private cnn As ADODB.Connection
Private col As Collection
Private sID As String
Private sPlan As String
Public TreeIndex As Long

Public Property Get Description() As String
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT DESCR FROM JOBSTEP000 WHERE (PROCPLANID='" & sPlan & _
        "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then Description = Trim(Nz(rst(0).Value, ""))
    Set rst = Nothing
End Property

Public Property Get ID() As String
    ID = sID
End Property
Public Property Let ID(ByVal s As String)
    sID = s
    RefreshResources
End Property

Public Property Get NextJS() As TProc
    On Error Resume Next
    Dim s As String
    Dim po As TProc
    Dim rst As ADODB.Recordset
    
    s = "SELECT NEXTJSID FROM JOBSTEP000 WHERE (PROCPLANID='" & sPlan & _
        "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then
        s = ""
        s = Trim(Nz(rst(0).Value, ""))
        If s <> "" Then
            Set po = New TProc
            po.ID = s
            po.ProcPlan = sPlan
        End If
    End If
    Set rst = Nothing
    Set NextJS = po
End Property

Public Property Get ProcPlan() As String
    ProcPlan = sPlan
End Property
Public Property Let ProcPlan(ByVal s As String)
    sPlan = s
    RefreshResources
End Property

Public Property Get ProcType() As Integer
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT TYPE FROM JOBSTEP000 WHERE (PROCPLANID='" & sPlan & _
        "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then ProcType = Nz(rst(0).Value, 0)
    Set rst = Nothing
End Property

Public Property Get Resources() As Collection
    Set Resources = col
End Property

Public Property Get Setup() As String
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT STIMEXP FROM JS" & Me.ProcType & "VR000 WHERE (PROCPLANID='" _
        & sPlan & "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then Setup = Trim(Nz(rst(0).Value, ""))
    Set rst = Nothing
End Property

Public Property Get Step() As String
    On Error Resume Next
    Dim s As String
    Dim rst As ADODB.Recordset
    
    s = "SELECT STEPEXP FROM JOBSTEP000 WHERE (PROCPLANID='" & sPlan & _
        "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Err.Number = 0 Then Step = Trim(Nz(rst(0).Value, ""))
    Set rst = Nothing
End Property

Public Property Get Tag() As Long
    Tag = 3
End Property

Private Sub Class_Initialize()
    Set cnn = Data
    Set col = New Collection
    sID = ""
    sPlan = ""
    TreeIndex = -1
End Sub
Private Sub Class_Terminate()
    Set cnn = Nothing
    Set col = Nothing
End Sub

Private Sub RefreshResources()
    On Error Resume Next
    Dim s As String
    Dim fld As Field
    Dim rst As ADODB.Recordset
    
    s = "SELECT RESID1, RESID2, RESID3, RESID4, RESID5, RESID6 " & _
        "FROM JOBSTEP000 WHERE (PROCPLANID='" & sPlan & _
        "') AND (JSID='" & sID & "');"
    Set rst = cnn.Execute(s, , adCmdText)
    If Not rst.EOF Then
        For Each fld In rst.Fields
            s = ""
            s = Trim(Nz(fld.Value, ""))
            If s <> "" Then col.Add s
        Next fld
    End If
    Set rst = Nothing
End Sub
